block W; // make blocks
int n=3;
int hi=-1,hj=-1;
block B[] = new block[9];  // blocks
Colors Clrs = new Colors(n);
void resetBlocks() { 
 // for (int i=0; i<n; i++) B[i] = new block(P(width/2,(i+0.5)*height/n),100,20,i+1,Clrs.next());
  for (int i=0; i<n; i++) B[i] = new block(P(width/2,(i+0.5)*height/n),0.2*width*(1+i)/sqrt(n),0.04*width*(1+i)/sqrt(n),1,Clrs.next());
  }
vec G=V(0,0); // acceleration
float f=0.00001; // friction
float s=20;  // rubberband constant for pulling
void pickBlocks() {for (int i=0; i<n; i++) B[i].pick(); }
void advanceBlocks() {for (int i=0; i<n; i++) B[i].update(1); }
void showBlocks() {for (int i=0; i<n; i++) B[i].show();}
void showPs() {for (int i=0; i<n; i++) B[i].showP();}
  
class block {
  float w, h;          // dimensions
  float d;                  // density
  color c;           // color
  boolean picked = false;     // true if being dragged
  float a=0.0, da=0.0;        // angle, and angular velocity
  float m = d*4*w*h;             // total mass
  float I = m*(sq(w)+sq(h))/3;  // Inertia
  float b=f*I;  // friction for translation and rotation 
  pt C=P(400,400); vec dC=V(0,0);  // center of mass and velocity
  pt A=P(0.8*w,0);           // anchor point for dragging (reset on pick)
  pt P=P(0,0);               // collision point 
  block(pt pC, float pw, float ph, float pd, color pc) {C.setTo(pC); w=pw; h=ph; d=pd; c=pc; m = d*4*w*h; I = m*(sq(w)+sq(h))/3; b=f*I; }
  void setTo (block X) {w=X.w; h=X.h; d=X.d; c=X.c; picked=X.picked; a=X.a; da=X.da; m=X.m; I=X.I; b=X.b; C.setTo(X.C); dC.setTo(X.dC); A.setTo(X.A); P.setTo(X.P);}
  block clone() {block X = new block(C,w,h,d,c); X.picked=picked; X.a=a; X.da=da; X.m=m; X.I=I; X.b=b; X.A.setTo(A); X.dC.setTo(dC); X.P.setTo(P); return X;}
  pt local(pt P) {vec I=R(V(1,0),a); vec J=R(I); vec CP=V(C,P); return P(dot(I,CP),dot(J,CP)); }
  pt global(pt P) {vec I=R(V(1,0),a); vec J=R(I); vec CP=V(C,P); return S(C,P.x,I,P.y,J); }
  vec global(vec V) {return R(V,a); }
  vec localNto(pt Q) {pt P=local(Q);
      boolean a=h*P.x-w*P.y>0; boolean b=h*P.x+w*P.y>0; 
      if(a&&b) return V(1,0); if(!a&&!b) return V(-1,0); if(!a&&b) return V(0,1);if(a&&!b) return V(0,-1); return V(0,0);}
  void show() {fill(c); stroke(black); push(); trans(C); rotate(a); rect(0,0,2*w,2*h); if (picked) A.show(4); pop(); if(picked&&mousePressed) Mouse().to(global(A)); }; 
  void showP() {fill(blue); global(P).show(7); noFill(); }; 
  pt hitP() { return global(P); }; 
  vec Nto(pt P) {return global(localNto(P)); }; 
  void showWire() {noFill(); stroke(c); push(); trans(C); rotate(a); rect(0,0,2*w,2*h); if (picked) A.show(4); pop(); if(picked&&mousePressed) Mouse().to(global(A)); }; 
  boolean contains(pt P, float e) {pt M=local(P); return ((abs(M.x)<w+e)&&(abs(M.y)<h+e)); };
  boolean contains(pt P) {pt M=local(P); return ((abs(M.x)<w)&&(abs(M.y)<h)); };
  boolean mouseIsIn() {return contains(Mouse()); };
  void pick() {picked=mouseIsIn(); A.setTo(local(Mouse()));}
  void update (float t) {
     C.add(t,dC);                 // update center of mass
     dC.add(-f*h*w*t,dC);       // subtracts friction deceleration from velocity
     dC.add(t,G);                 // adds gravity to velocity
     if(picked&&mousePressed&&!keyPressed) dC.add(t*s/m,V(global(A),Mouse()));  // adds spring force to velocity
     a+=da*t;                 // adds angular velocity
     da-=t*f*h*w*da;           // subtracts rotational friction from angular velocity
     if(picked&&mousePressed&&!keyPressed) da+=t*s/I*dot(R(O(),A),V(A,local(Mouse()))); // adds spring torque to angular velocity
     }; 
  }     


 
